Package org.flowable.dmn.api

# Interface DmnDecisionQuery

All Superinterfaces:
  `Query<DmnDecisionQuery,DmnDecision>`

public interface DmnDecisionQuery extends Query<DmnDecisionQuery,DmnDecision>
Allows programmatic querying of `DmnDecision`s.

Author:
  Tijs Rademakers, Joram Barrez, Yvo Swillens

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.flowable.common.engine.api.query.Query

  `Query.NullHandlingOnOrder`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DmnDecisionQuery`
  `decisionCategory(String decisionCategory)`
  Only select decisions with the given category.
  `DmnDecisionQuery`
  `decisionCategoryLike(String decisionCategoryLike)`
  Only select decisions where the category matches the given parameter.
  `DmnDecisionQuery`
  `decisionCategoryNotEquals(String categoryNotEquals)`
  Only select deployments that have a different category then the given one.
  `DmnDecisionQuery`
  `decisionId(String decisionId)`
  Only select decision with the given id.
  `DmnDecisionQuery`
  `decisionIds(Set<String> decisionIds)`
  Only select decisions with the given ids.
  `DmnDecisionQuery`
  `decisionKey(String decisionKey)`
  Only select decision with the given key.
  `DmnDecisionQuery`
  `decisionKeyLike(String decisionKeyLike)`
  Only select decisions where the key matches the given parameter.
  `DmnDecisionQuery`
  `decisionName(String decisionName)`
  Only select decisions with the given name.
  `DmnDecisionQuery`
  `decisionNameLike(String decisionNameLike)`
  Only select decisions where the name matches the given parameter.
  `DmnDecisionQuery`
  `decisionResourceName(String resourceName)`
  Only select decision with the given resource name.
  `DmnDecisionQuery`
  `decisionResourceNameLike(String resourceNameLike)`
  Only select decision with a resource name like the given .
  `DmnDecisionQuery`
  `decisionTenantId(String tenantId)`
  Only select decisions that have the given tenant id.
  `DmnDecisionQuery`
  `decisionTenantIdLike(String tenantIdLike)`
  Only select decisions with a tenant id like the given one.
  `DmnDecisionQuery`
  `decisionType(String decisionType)`
  Only select decisions with the given type.
  `DmnDecisionQuery`
  `decisionTypeLike(String decisionType)`
  Only select decisions like the given type.
  `DmnDecisionQuery`
  `decisionVersion(Integer decisionVersion)`
  Only select decisions with a certain version.
  `DmnDecisionQuery`
  `decisionVersionGreaterThan(Integer decisionVersion)`
  Only select decisions which version are greater than a certain version.
  `DmnDecisionQuery`
  `decisionVersionGreaterThanOrEquals(Integer decisionVersion)`
  Only select decisions which version are greater than or equals a certain version.
  `DmnDecisionQuery`
  `decisionVersionLowerThan(Integer decisionVersion)`
  Only select decisions which version are lower than a certain version.
  `DmnDecisionQuery`
  `decisionVersionLowerThanOrEquals(Integer decisionVersion)`
  Only select decisions which version are lower than or equals a certain version.
  `DmnDecisionQuery`
  `decisionWithoutTenantId()`
  Only select decisions that do not have a tenant id.
  `DmnDecisionQuery`
  `deploymentId(String deploymentId)`
  Only select decisions that are deployed in a deployment with the given deployment id
  `DmnDecisionQuery`
  `deploymentIds(Set<String> deploymentIds)`
  Select decisions that are deployed in deployments with the given set of ids
  `DmnDecisionQuery`
  `latestVersion()`
  Only select the decisions which are the latest deployed (ie. which have the highest version number for the given key).
  `DmnDecisionQuery`
  `orderByDecisionCategory()`
  Order by the category of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDecisionId()`
  Order by the id of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDecisionKey()`
  Order by decision key (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDecisionName()`
  Order by the name of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDecisionType()`
  Order by decision type (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDecisionVersion()`
  Order by the version of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByDeploymentId()`
  Order by deployment id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `orderByTenantId()`
  Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `DmnDecisionQuery`
  `parentDeploymentId(String parentDeploymentId)`
  Only select decisions that are deployed in a deployment with the given parent deployment id

  ### Methods inherited from interface org.flowable.common.engine.api.query.Query

  `asc, count, desc, list, listPage, orderBy, orderBy, singleResult`

- ## Method Details

  - ### decisionId

    DmnDecisionQuery decisionId(String decisionId)
    Only select decision with the given id.

  - ### decisionIds

    DmnDecisionQuery decisionIds(Set<String> decisionIds)
    Only select decisions with the given ids.

  - ### decisionCategory

    DmnDecisionQuery decisionCategory(String decisionCategory)
    Only select decisions with the given category.

  - ### decisionCategoryLike

    DmnDecisionQuery decisionCategoryLike(String decisionCategoryLike)
    Only select decisions where the category matches the given parameter. The syntax that should be used is the same as in SQL, eg. %test%

  - ### decisionCategoryNotEquals

    DmnDecisionQuery decisionCategoryNotEquals(String categoryNotEquals)
    Only select deployments that have a different category then the given one.
    See Also:
      - `DmnDeploymentBuilder.category(String)`

  - ### decisionName

    DmnDecisionQuery decisionName(String decisionName)
    Only select decisions with the given name.

  - ### decisionNameLike

    DmnDecisionQuery decisionNameLike(String decisionNameLike)
    Only select decisions where the name matches the given parameter. The syntax that should be used is the same as in SQL, eg. %test%

  - ### deploymentId

    DmnDecisionQuery deploymentId(String deploymentId)
    Only select decisions that are deployed in a deployment with the given deployment id

  - ### deploymentIds

    DmnDecisionQuery deploymentIds(Set<String> deploymentIds)
    Select decisions that are deployed in deployments with the given set of ids

  - ### parentDeploymentId

    DmnDecisionQuery parentDeploymentId(String parentDeploymentId)
    Only select decisions that are deployed in a deployment with the given parent deployment id

  - ### decisionKey

    DmnDecisionQuery decisionKey(String decisionKey)
    Only select decision with the given key.

  - ### decisionKeyLike

    DmnDecisionQuery decisionKeyLike(String decisionKeyLike)
    Only select decisions where the key matches the given parameter. The syntax that should be used is the same as in SQL, eg. %test%

  - ### decisionVersion

    DmnDecisionQuery decisionVersion(Integer decisionVersion)
    Only select decisions with a certain version. Particularly useful when used in combination with `decisionKey(String)`

  - ### decisionVersionGreaterThan

    DmnDecisionQuery decisionVersionGreaterThan(Integer decisionVersion)
    Only select decisions which version are greater than a certain version.

  - ### decisionVersionGreaterThanOrEquals

    DmnDecisionQuery decisionVersionGreaterThanOrEquals(Integer decisionVersion)
    Only select decisions which version are greater than or equals a certain version.

  - ### decisionVersionLowerThan

    DmnDecisionQuery decisionVersionLowerThan(Integer decisionVersion)
    Only select decisions which version are lower than a certain version.

  - ### decisionVersionLowerThanOrEquals

    DmnDecisionQuery decisionVersionLowerThanOrEquals(Integer decisionVersion)
    Only select decisions which version are lower than or equals a certain version.

  - ### latestVersion

    DmnDecisionQuery latestVersion()
    Only select the decisions which are the latest deployed (ie. which have the highest version number for the given key).

    Can also be used without any other criteria (ie. query.latest().list()), which will then give all the latest versions of all the deployed decisions.

    Throws:
      `FlowableIllegalArgumentException` - if used in combination with `decisionVersion(Integer)` or `deploymentId(String)`

  - ### decisionResourceName

    DmnDecisionQuery decisionResourceName(String resourceName)
    Only select decision with the given resource name.

  - ### decisionResourceNameLike

    DmnDecisionQuery decisionResourceNameLike(String resourceNameLike)
    Only select decision with a resource name like the given .

  - ### decisionTenantId

    DmnDecisionQuery decisionTenantId(String tenantId)
    Only select decisions that have the given tenant id.

  - ### decisionTenantIdLike

    DmnDecisionQuery decisionTenantIdLike(String tenantIdLike)
    Only select decisions with a tenant id like the given one.

  - ### decisionWithoutTenantId

    DmnDecisionQuery decisionWithoutTenantId()
    Only select decisions that do not have a tenant id.

  - ### decisionType

    DmnDecisionQuery decisionType(String decisionType)
    Only select decisions with the given type.

  - ### decisionTypeLike

    DmnDecisionQuery decisionTypeLike(String decisionType)
    Only select decisions like the given type.

  - ### orderByDecisionCategory

    DmnDecisionQuery orderByDecisionCategory()
    Order by the category of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDecisionKey

    DmnDecisionQuery orderByDecisionKey()
    Order by decision key (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDecisionId

    DmnDecisionQuery orderByDecisionId()
    Order by the id of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDecisionVersion

    DmnDecisionQuery orderByDecisionVersion()
    Order by the version of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDecisionName

    DmnDecisionQuery orderByDecisionName()
    Order by the name of the decisions (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDeploymentId

    DmnDecisionQuery orderByDeploymentId()
    Order by deployment id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTenantId

    DmnDecisionQuery orderByTenantId()
    Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDecisionType

    DmnDecisionQuery orderByDecisionType()
    Order by decision type (needs to be followed by `Query.asc()` or `Query.desc()`).